; ---------------------------------------------------------------------------
; |             SIGNALIZACE NEZAPNUTCH SVTEL V AUTOMOBILU                 |
; |             Petr imon             petr_simi@centrum.cz                 |
; ---------------------------------------------------------------------------

por	bit p1.7		;kontrola poklesu napt
mot	bit p1.6		;kontrola stavu motoru
sv	bit p1.5		;kontrola stavu svtel
zvuk	bit p1.4		;vstup s piezo
opak	bit p3.3		;opakovat zvuk?
p_por	bit p3.4		;pout kontrolu poklesu napt?
p_mot	bit p3.5		;pout kontrolu zapnut motoru?
;*************************	inicializace
init:	setb zvuk
	setb por
	setb mot
	setb sv
	setb p_por
	setb p_mot
;*************************	 start programu
start:	jnb p_mot,motor		;sko, pokud se m kontrolovat, zda b motor
	jnb p_por,pokles	;sko, pokud se m kontrolovat, zda dojde k poklesu napt
	call cekej		;pokud se nem pout ani jedna z kontrol, tak pouze pokme...
	jnb sv,start1		;...zkontrolujeme, jestli u nhodou svtla nejsou zapnut. Pokud jsou, tak skome...
	call beep		;...ppneme...
start1:	jmp $			;a zastavme se. Dl u se nebude nic provdt.
;*************************	 bude se kontrolovat pokles napt
pokles: jnb por,$		;ek, dokud nedojde k poklesu napt...
	call cekej		;pokme
	jnb sv,pokles		;zkontrolujeme, jestli u nhodou svtla nejsou zapnut. Pokud jsou, tak skome.
pokle1:	call beep		;ppneme
	jb por,$		;pro jistotu zkontrolujeme, jestli jet pod nen napt poklesl. Pokud ano, tak ekme
	jmp pokles		;vrtme se na zatek a meme znovu kontrolovat pokles napt
;*************************	 bude se kontrolovat, jestli b motor
motor:	jb mot,$		;ekme dokud se nerozsvt kontrolka mazn
motor1:	jnb mot,$		;ekme dokud kontrolka nezhasne (nastartovn motoru)
	call cek
	jnb mot,motor1		;zkontrolujem, jestli nhodou jet furt nesvt kontrolka
	jnb sv,motor		;pokud jsou svtla zapnut, tak skome na zatek
	call beep		;ppneme
	jnb opak,motor4		;pokud je povoleno opakovn, tak skome
	jmp motor	
motor4:	mov r4,#8
motor3:	call cekej
	jnb sv,motor		;pokud jsou u svtla zapnut, tak skome na zatek
	jnb mot,motor		;pokud je motor vypnut, skome na zatek
	djnz r4,motor3
	jnb mot,motor		;pokud je motor vypnut, skome na zatek
	jnb sv,motor		;pokud jsou svtla zapnut, skome na zatek
	call beep
	jmp motor4		;a znovu opakujeme...
;*************************	 pauza
cekej:	mov r5,#26
cekej1:	djnz r7,$
	djnz r6,$-2
	jnb sv,cekej2
	djnz r5,cekej1
cekej2:	ret
	jmp init
;*************************	 pauza
cek:	mov r5,#26
cek1:	djnz r7,$
	djnz r6,$-2
	jnb sv,cek2
	jnb mot,cek2
	djnz r5,cek1
cek2:	ret
	jmp init
;*************************	 ppnut
beep:	clr zvuk
	mov r5,#3
	djnz r7,$
	djnz r6,$-2
	djnz r5,$-4
	setb zvuk
	ret

	jmp init

	end
	
